From: Michel Normand <normand@linux.vnet.ibm.com>
Subject: mongodb_2_4_10_ppc_patch_based_on_mongo_ibmsoe
Date: Fri, 06 Feb 2015 17:28:47 +0100

This is a step1 patch (without step2 related to src/third_party/v8-3.14)
mongodb_2_4_10_ppc_patch_based_on_mongo_ibmsoe.patch
is the git merge of all commits of r2.4.9-ppc branch applied to r2.4.10-ppc branch

It has been created as detailed below.
TODO: need to check who is pushing upstream the related change of mongo_ibmsoe
note:  gbr, gco and gta are aliases of git commands

* details of actions to create this patch:
    1_ clone mongo ibmsoe git tree
    2_ identify the commit id 08da87a as base of r2.4.9-ppc branch
    3_ update git tree with last changes of mongodb git tree
       with remote add and fetch commands
    4_ identify the commit id e3d7895 associated to 2.4.10 release
       create a local r2.4.10-ppc on this same id e3d7895
    5_ do the git merge of r2.4.9-ppc to r2.4.10-ppc
       ultimately use git diff command to create the patch
    === 1_
    $git clone https://github.com/ibmsoe/mongo
    ...
    === 2_
    $gco r2.4.9-ppc
    $gbr |grep \^\*
    * r2.4.9-ppc
    $git rev-list --boundary $(git rev-parse --abbrev-ref HEAD)...master | grep ^- | cut -c2-
    08da87aa68a489dab7f24e059916b1ba2aa33452
    ...
    $gta
    ...
    | * 3201046 (HEAD, origin/r2.4.9-ppc, origin/HEAD, r2.4.9-ppc) Updated buildin.md
    ...
    | * | | 3018a05 SERVER-8914: rename document.scanned metric
    |/ / /
    * | | 08da87a SERVER-8880 Visual Studio -- remove /OPT:REF and /OPT:ICF
    ...
    | | * 52fe0d2 (tag: r2.4.9) BUMP 2.4.9
    | | * 3e3734c post 2.4.9-rc0
    === 3_
    $git remote add mongodb https://github.com/mongodb/mongo.git
    $git fetch mongodb
    $gco v2.4
    $gbr | grep \^\*
    * v2.4
    $git merge mongodb/v2.4
    === 4_
    $gta |grep 2.4.10
    | | | * d218cd5 post 2.4.10
    | | | * e3d7895 (HEAD, tag: r2.4.10) BUMP 2.4.10
    | | | * e8d714a post 2.4.10-rc0
    | | | * 6c3b955 (tag: r2.4.10-rc0) BUMP 2.4.10-rc0
    | * | | 2e4f101 defensive
    $gco -b r2.4.10-ppc e3d7895
    Switched to a new branch 'r2.4.10-ppc'
    $gbr |grep 2.4
    * r2.4.10-ppc
      r2.4.9-aixppc
      r2.4.9-ppc
      v2.4
      v2.4.1
    $gta |grep r2.4.10.ppc
    | | | * e3d7895 (HEAD, tag: r2.4.10, r2.4.10-ppc) BUMP 2.4.10
    === 5_
    $git merge r2.4.9-ppc
    $git diff -u --stat r2.4.10 r2.4.10-ppc | grep -v '^[a-z]' \
    > /tmp/mongodb_2_4_10_ppc_patch_based_on_mongo_ibmsoe.patch
    ===

diff --git a/README b/README
index 1d059c6..6e7f5b9 100755
--- a/README
+++ b/README
@@ -1,3 +1,5 @@
+Porting 2.4.9 for Power Linux
+
 MongoDB README
 
 Welcome to MongoDB!
diff --git a/SConstruct b/SConstruct
index ab01a71..548ce8d 100644
--- a/SConstruct
+++ b/SConstruct
@@ -149,6 +149,7 @@ add_option( "static-libstdc++" , "statically link libstdc++" , 0 , False )
 # base compile flags
 add_option( "64" , "whether to force 64 bit" , 0 , True , "force64" )
 add_option( "32" , "whether to force 32 bit" , 0 , True , "force32" )
+add_option( "31" , "whether to force 31 bit for s390x" , 0 , True , "force31" )
 
 add_option( "cxx", "compiler to use" , 1 , True )
 add_option( "cc", "compiler to use for c" , 1 , True )
@@ -259,6 +260,8 @@ windows = False
 freebsd = False
 openbsd = False
 solaris = False
+bigendian = True # For snappy
+force31 = has_option( "force31" )
 force32 = has_option( "force32" ) 
 force64 = has_option( "force64" )
 if not force64 and not force32 and os.getcwd().endswith( "mongo-64" ):
@@ -551,6 +554,10 @@ elif os.sys.platform.startswith("linux"):
     if has_option( "static-libstdc++" ):
         env.Append( LINKFLAGS=" -static-libstdc++ " )
 
+    if os.uname()[4] == "s390x":
+        env.Prepend(CPPDEFINES=[ "_BIG_ENDIAN=1" ] )
+        env.Prepend(CPPDEFINES=[ "__BIG_ENDIAN__=1" ] )
+
 elif "sunos5" == os.sys.platform:
      nix = True
      solaris = True
@@ -706,7 +713,6 @@ if nix:
                          "-fno-strict-aliasing",
                          "-ggdb",
                          "-pthread",
-                         "-Wall",
                          "-Wsign-compare",
                          "-Wno-unknown-pragmas",
                          "-Winvalid-pch"] )
@@ -751,6 +757,10 @@ if nix:
         env.Append( CCFLAGS="-m32" )
         env.Append( LINKFLAGS="-m32" )
 
+    if force31:
+        env.Append( CCFLAGS="-m31" )
+        env.Append( LINKFLAGS="-m31" )
+
     if has_option( "gdbserver" ):
         env.Append( CPPDEFINES=["USE_GDBSERVER"] )
 
@@ -872,6 +882,9 @@ def doConfigure(myenv):
         if not conf.CheckLib("execinfo"):
             Exit(1)
 
+    #hcj added for snappy
+    Export( "bigendian" )
+
     # 'tcmalloc' needs to be the last library linked. Please, add new libraries before this 
     # point.
     if get_option('allocator') == 'tcmalloc':
diff --git a/src/mongo/bson/bson-inl.h b/src/mongo/bson/bson-inl.h
index dfe7568..fac190b 100644
--- a/src/mongo/bson/bson-inl.h
+++ b/src/mongo/bson/bson-inl.h
@@ -186,7 +186,7 @@ dodouble:
 
     inline BSONObj BSONElement::codeWScopeObject() const {
         verify( type() == CodeWScope );
-        int strSizeWNull = *(int *)( value() + 4 );
+        int strSizeWNull = little<int>::ref( value() + 4 );
         return BSONObj( value() + 4 + 4 + strSizeWNull );
     }
 
@@ -511,15 +511,15 @@ dodouble:
             break;
         }
         case CodeWScope: {
-            int totalSize = *( int * )( value() );
+            int totalSize = little<int>::ref( value() );
             massert( 10322 ,  "Invalid CodeWScope size", totalSize >= 8 );
-            int strSizeWNull = *( int * )( value() + 4 );
+            int strSizeWNull = little<int>::ref( value() + 4 );
             massert( 10323 ,  "Invalid CodeWScope string size", totalSize >= strSizeWNull + 4 + 4 );
             massert( 10324 ,  "Invalid CodeWScope string size",
                      strSizeWNull > 0 &&
                      (strSizeWNull - 1) == mongo::strnlen( codeWScopeCode(), strSizeWNull ) );
             massert( 10325 ,  "Invalid CodeWScope size", totalSize >= strSizeWNull + 4 + 4 + 4 );
-            int objSize = *( int * )( value() + 4 + 4 + strSizeWNull );
+            int objSize = little<int>::ref( value() + 4 + 4 + strSizeWNull );
             massert( 10326 ,  "Invalid CodeWScope object size", totalSize == 4 + 4 + strSizeWNull + objSize );
             // Subobject validation handled elsewhere.
         }
diff --git a/src/mongo/bson/bson_db.h b/src/mongo/bson/bson_db.h
index c421816..2cecd5a 100644
--- a/src/mongo/bson/bson_db.h
+++ b/src/mongo/bson/bson_db.h
@@ -49,7 +49,7 @@ namespace mongo {
 
     inline OpTime BSONElement::_opTime() const {
         if( type() == mongo::Date || type() == Timestamp )
-            return OpTime( *reinterpret_cast< const unsigned long long* >( value() ) );
+            return OpTime( little<unsigned long long>::ref( value() ) );
         return OpTime();
     }
 
@@ -59,7 +59,7 @@ namespace mongo {
         case Code:
             return std::string(valuestr(), valuestrsize()-1);
         case CodeWScope:
-            return std::string(codeWScopeCode(), *(int*)(valuestr())-1);
+            return std::string(codeWScopeCode(), little<int>::ref(valuestr()) - 1 );
         default:
             log() << "can't convert type: " << (int)(type()) << " to code" << std::endl;
         }
diff --git a/src/mongo/bson/bson_validate.cpp b/src/mongo/bson/bson_validate.cpp
index cd88190..3ed02f4 100644
--- a/src/mongo/bson/bson_validate.cpp
+++ b/src/mongo/bson/bson_validate.cpp
@@ -36,8 +36,11 @@ namespace mongo {
                 if ( ( _position + sizeof(N) ) > _maxLength )
                     return false;
                 if ( out ) {
-                    const N* temp = reinterpret_cast<const N*>(_buffer + _position);
-                    *out = *temp;
+//hcj for little
+                    //const N* temp = reinterpret_cast<const N*>(_buffer + _position);
+                    
+                    const N* temp = (const N*)(_buffer + _position);
+                    *out = little<int>::ref(temp);
                 }
                 _position += sizeof(N);
                 return true;
@@ -136,8 +139,8 @@ namespace mongo {
         Status validateElementInfo(Buffer* buffer, ValidationState::State* nextState) {
             Status status = Status::OK();
 
-            char type;
-            if ( !buffer->readNumber<char>(&type) )
+            signed char type;
+            if ( !buffer->readNumber<signed char>(&type) )
                 return Status( ErrorCodes::InvalidBSON, "invalid bson" );
 
             if ( type == EOO ) {
diff --git a/src/mongo/bson/bsonelement.h b/src/mongo/bson/bsonelement.h
index f094ab9..f02619d 100644
--- a/src/mongo/bson/bsonelement.h
+++ b/src/mongo/bson/bsonelement.h
@@ -20,7 +20,7 @@
 #include <string.h> // strlen
 #include <string>
 #include <vector>
-
+#include "util/bswap.h"
 #include "mongo/bson/bsontypes.h"
 #include "mongo/bson/oid.h"
 #include "mongo/platform/cstdint.h"
@@ -176,7 +176,7 @@ namespace mongo {
             @see Bool(), trueValue()
         */
         Date_t date() const {
-            return *reinterpret_cast< const Date_t* >( value() );
+            return Date_t( little<unsigned long long>::ref( value() ) );
         }
 
         /** Convert the value to boolean, regardless of its type, in a javascript-like fashion
@@ -191,11 +191,11 @@ namespace mongo {
         bool isNumber() const;
 
         /** Return double value for this field. MUST be NumberDouble type. */
-        double _numberDouble() const {return (reinterpret_cast< const PackedDouble* >( value() ))->d; }
+        double _numberDouble() const {return little<double>::ref( value() ); }
         /** Return int value for this field. MUST be NumberInt type. */
-        int _numberInt() const {return *reinterpret_cast< const int* >( value() ); }
+        int _numberInt() const {return little<int>::ref( value() ); }
         /** Return long long value for this field. MUST be NumberLong type. */
-        long long _numberLong() const {return *reinterpret_cast< const long long* >( value() ); }
+        long long _numberLong() const {return little<long long>::ref( value() ); }
 
         /** Retrieve int value for the element safely.  Zero returned if not a number. */
         int numberInt() const;
@@ -234,12 +234,12 @@ namespace mongo {
             @return string size including terminating null
         */
         int valuestrsize() const {
-            return *reinterpret_cast< const int* >( value() );
+            return little<int>::ref( value() );
         }
 
         // for objects the size *includes* the size of the size field
         size_t objsize() const {
-            return static_cast< const size_t >( *reinterpret_cast< const uint32_t* >( value() ) );
+            return little<size_t>::ref( value() );
         }
 
         /** Get a string's value.  Also gives you start of the real data for an embedded object.
@@ -268,7 +268,7 @@ namespace mongo {
          *  This INCLUDES the null char at the end */
         int codeWScopeCodeLen() const {
             massert( 16178 , "not codeWScope" , type() == CodeWScope );
-            return *(int *)( value() + 4 );
+            return little<int>::ref( value() + 4);
         }
 
         /** Get the scope SavedContext of a CodeWScope data element.
@@ -396,11 +396,11 @@ namespace mongo {
         }
 
         Date_t timestampTime() const {
-            unsigned long long t = ((unsigned int*)(value() + 4 ))[0];
+            unsigned long long t = little<unsigned int>::ref( value() + 4 );
             return t * 1000;
         }
         unsigned int timestampInc() const {
-            return ((unsigned int*)(value() ))[0];
+            return little<unsigned int>::ref( value() );
         }
 
         const char * dbrefNS() const {
@@ -411,7 +411,7 @@ namespace mongo {
         const mongo::OID& dbrefOID() const {
             uassert( 10064 ,  "not a dbref" , type() == DBRef );
             const char * start = value();
-            start += 4 + *reinterpret_cast< const int* >( start );
+            start += 4 + little<int>::ref( start );
             return *reinterpret_cast< const mongo::OID* >( start );
         }
 
@@ -483,11 +483,11 @@ namespace mongo {
         // NOTE Behavior changes must be replicated in Value::coerceToBool().
         switch( type() ) {
         case NumberLong:
-            return *reinterpret_cast< const long long* >( value() ) != 0;
+            return little<long long>::ref( value() ) != 0;
         case NumberDouble:
-            return (reinterpret_cast < const PackedDouble* >(value ()))->d != 0;
+            return little<double>::ref( value() ) != 0;
         case NumberInt:
-            return *reinterpret_cast< const int* >( value() ) != 0;
+            return little<int>::ref( value() ) != 0;
         case mongo::Bool:
             return boolean();
         case EOO:
@@ -533,9 +533,9 @@ namespace mongo {
         case NumberDouble:
             return _numberDouble();
         case NumberInt:
-            return *reinterpret_cast< const int* >( value() );
+            return little<int>::ref( value() );
         case NumberLong:
-            return (double) *reinterpret_cast< const long long* >( value() );
+            return little<long long>::ref( value() );
         default:
             return 0;
         }
diff --git a/src/mongo/bson/bsonobj.h b/src/mongo/bson/bsonobj.h
index ecf172a..d7b48b4 100644
--- a/src/mongo/bson/bsonobj.h
+++ b/src/mongo/bson/bsonobj.h
@@ -277,7 +277,7 @@ namespace mongo {
             return _objdata;
         }
         /** @return total size of the BSON object in bytes */
-        int objsize() const { return *(reinterpret_cast<const int*>(objdata())); }
+        int objsize() const { return little<int>::ref(objdata()); }
 
         /** performs a cursory check on the object's size only. */
         bool isValid() const;
@@ -376,8 +376,8 @@ namespace mongo {
         /** @return A hash code for the object */
         int hash() const {
             unsigned x = 0;
-            const char *p = objdata();
-            for ( int i = 0; i < objsize(); i++ )
+            const signed char *p = (signed char*)objdata();
+            for ( int i = 0, n = objsize(); i < n; i++ )
                 x = x * 131 + p[i];
             return (x & 0x7fffffff) | 0x8000000; // must be > 0
         }
diff --git a/src/mongo/bson/bsonobjbuilder.h b/src/mongo/bson/bsonobjbuilder.h
index c0c3d0b..2b7aba5 100644
--- a/src/mongo/bson/bsonobjbuilder.h
+++ b/src/mongo/bson/bsonobjbuilder.h
@@ -108,7 +108,7 @@ namespace mongo {
         BSONObjBuilder& appendObject(const StringData& fieldName, const char * objdata , int size = 0 ) {
             verify( objdata );
             if ( size == 0 ) {
-                size = *((int*)objdata);
+                size = little<int>::ref( objdata );
             }
 
             verify( size > 4 && size < 100000000 );
@@ -666,7 +666,7 @@ namespace mongo {
             _b.appendNum((char) EOO);
             char *data = _b.buf() + _offset;
             int size = _b.len() - _offset;
-            *((int*)data) = size;
+            little<int>::ref( data ) = size;
             if ( _tracker )
                 _tracker->got( size );
             return data;
diff --git a/src/mongo/bson/oid.cpp b/src/mongo/bson/oid.cpp
index e96b076..2643212 100644
--- a/src/mongo/bson/oid.cpp
+++ b/src/mongo/bson/oid.cpp
@@ -58,7 +58,7 @@ namespace mongo {
         unsigned p = ourPid();
         x._pid ^= (unsigned short) p;
         // when the pid is greater than 16 bits, let the high bits modulate the machine id field.
-        unsigned short& rest = (unsigned short &) x._machineNumber[1];
+         little<unsigned short>& rest = little<unsigned short>::ref (&x._machineNumber[1]);
         rest ^= p >> 16;
     }
 
@@ -68,7 +68,7 @@ namespace mongo {
         // we only call this once per process
         scoped_ptr<SecureRandom> sr( SecureRandom::create() );
         int64_t n = sr->nextInt64();
-        OID::MachineAndPid x = ourMachine = reinterpret_cast<OID::MachineAndPid&>(n);
+        OID::MachineAndPid x = ourMachine = (OID::MachineAndPid&) n;
         foldInPid(x);
         return x;
     }
@@ -90,7 +90,7 @@ namespace mongo {
         x[1] = ourMachineAndPid._machineNumber[1];
         x[2] = ourMachineAndPid._machineNumber[2];
         x[3] = 0;
-        return (unsigned&) x[0];
+        return little<unsigned>::ref( x );
     }
 
     void OID::justForked() {
@@ -107,37 +107,23 @@ namespace mongo {
         static AtomicUInt inc = static_cast<unsigned>(
             scoped_ptr<SecureRandom>(SecureRandom::create())->nextInt64());
 
-        {
-            unsigned t = (unsigned) time(0);
-            unsigned char *T = (unsigned char *) &t;
-            _time[0] = T[3]; // big endian order because we use memcmp() to compare OID's
-            _time[1] = T[2];
-            _time[2] = T[1];
-            _time[3] = T[0];
-        }
+        big<unsigned>::ref( _time ) = time( 0 );
 
         _machineAndPid = ourMachineAndPid;
 
         {
-            int new_inc = inc++;
-            unsigned char *T = (unsigned char *) &new_inc;
-            _inc[0] = T[2];
-            _inc[1] = T[1];
-            _inc[2] = T[0];
+            // 24 bits big endian
+            unsigned int new_inc = inc++;
+            _inc[0] = new_inc >> 16;
+            _inc[1] = new_inc >>  8;
+            _inc[2] = new_inc;
         }
     }
 
     static AtomicUInt64 _initSequential_sequence;
     void OID::initSequential() {
 
-        {
-            unsigned t = (unsigned) time(0);
-            unsigned char *T = (unsigned char *) &t;
-            _time[0] = T[3]; // big endian order because we use memcmp() to compare OID's
-            _time[1] = T[2];
-            _time[2] = T[1];
-            _time[3] = T[0];
-        }
+        big<unsigned>::ref( _time ) = time( 0 );
         
         {
             unsigned long long nextNumber = _initSequential_sequence.fetchAndAdd(1);
@@ -159,26 +145,16 @@ namespace mongo {
 
     void OID::init(Date_t date, bool max) {
         int time = (int) (date / 1000);
-        char* T = (char *) &time;
-        data[0] = T[3];
-        data[1] = T[2];
-        data[2] = T[1];
-        data[3] = T[0];
-
+        big<unsigned>::ref( data ) = time;
+        
         if (max)
-            *(long long*)(data + 4) = 0xFFFFFFFFFFFFFFFFll;
+            little<long long>::ref(data + 4) = 0xFFFFFFFFFFFFFFFFll;
         else
-            *(long long*)(data + 4) = 0x0000000000000000ll;
+            little<long long>::ref(data + 4) = 0x0000000000000000ll;
     }
 
     time_t OID::asTimeT() {
-        int time;
-        char* T = (char *) &time;
-        T[0] = data[3];
-        T[1] = data[2];
-        T[2] = data[1];
-        T[3] = data[0];
-        return time;
+        return big<int>::ref( data );
     }
 
     const string BSONObjBuilder::numStrs[] = {
